import sc.analysis.*;
import sc.node.*;
import sa.*;
import util.Type;

public class Sc2sa extends DepthFirstAdapter
{
    private SaNode returnValue ;
    private Type returnType;

    public void defaultIn(@SuppressWarnings("unused") Node node)
    {
	//System.out.println("<" + node.getClass().getSimpleName() + ">");
    }

    public void defaultOut(@SuppressWarnings("unused") Node node)
    {
	//System.out.println("</" + node.getClass().getSimpleName() + ">");
    }
    
    public SaNode getRoot()
    {
	return this.returnValue;
    }

    @Override
    public void caseAProgramme(AProgramme node){
        SaLDecVar variables ;
        SaLDecFonc fonctions;
        inAProgramme(node);
        node.getListedecvar().apply(this);
        variables =  (SaLDecVar) this.returnValue;
        node.getListedecfonc().apply(this) ;
        fonctions = (SaLDecFonc) this.returnValue;
        node.getListedecfonc().apply(this);
        this.returnValue = new SaProg(variables , fonctions);
        outAProgramme(node);
    }
    @Override
    public void caseAListeDesVariablesListedecvar(AListeDesVariablesListedecvar node){
        SaDecVar tete ;
        SaLDecVar queue;
        inAListeDesVariablesListedecvar(node);
        node.getDecvar().apply(this);
        tete = (SaDecVar) this.returnValue;
        node.getListedecvarp().apply(this);
        queue = (SaLDecVar) this.returnValue;
        this.returnValue = new SaLDecVar(tete, queue);
        outAListeDesVariablesListedecvar(node);

    }
    @Override
    public void caseAVideListedecvar(AVideListedecvar node)
    {
        inAVideListedecvar(node);
        this.returnValue = null;
        outAVideListedecvar(node);
    }
    public void caseAListeDesVariablesPrimeListedecvarp(AListeDesVariablesPrimeListedecvarp node){
        SaDecVar tetep ;
        SaLDecVar queuep ;
        inAListeDesVariablesPrimeListedecvarp(node);
        node.getDecvar().apply(this);
        tetep = (SaDecVar) this.returnValue;
        node.getListedecvarp().apply(this);
        queuep = (SaLDecVar) this.returnValue;
        this.returnValue = new SaLDecVar(tetep,queuep);
        outAListeDesVariablesPrimeListedecvarp(node);



    }
    @Override
    public void caseAVideListedecvarp(AVideListedecvarp node)
    {
        inAVideListedecvarp(node);
        this.returnValue = null;
        outAVideListedecvarp(node);
    }
    @Override
    public void caseAType1Decvar(AType1Decvar node)
    {
        Type type ;
        String identif;
        inAType1Decvar(node);
        node.getType().apply(this);
        type = this.returnType;
        identif = node.getIdentif().getText();
        this.returnValue = new SaDecVarSimple(identif,type);
        outAType1Decvar(node);
    }
    @Override
    public void caseAType2Decvar(AType2Decvar node)
    {
        Type type ;
        String identif ;
        int nombre = 0;
        inAType2Decvar(node);
        node.getType().apply(this);
        type = this.returnType;
        node.getIdentif().apply(this);
        identif = node.getIdentif().getText();
        node.getNombre().apply(this);
        nombre = Integer.parseInt(node.getNombre().getText());
        this.returnValue = new SaDecTab(identif,type,nombre);
        outAType2Decvar(node);
    }
    @Override
    public void caseAListeDesFonctionsListedecfonc(AListeDesFonctionsListedecfonc node)
    {
        SaDecFonc fonc = null ;
        SaLDecFonc lfonc = null ;
        inAListeDesFonctionsListedecfonc(node);
        node.getDecfonc().apply(this);
        fonc = (SaDecFonc) this.returnValue;
        node.getListedecfonc().apply(this);
        lfonc = (SaLDecFonc) this.returnValue;
        this.returnValue = new SaLDecFonc(fonc,lfonc);
        outAListeDesFonctionsListedecfonc(node);
    }
    @Override
    public void caseAVideListedecfonc(AVideListedecfonc node)
    {
        inAVideListedecfonc(node);
        this.returnValue = null;
        outAVideListedecfonc(node);
    }
    @Override
    public void caseADecfonc(ADecfonc node)
    {
        Type type ;
        String identif ;
        SaLDecVar parametre ;
        SaLDecVar variable ;
        SaInst bloc ;
        inADecfonc(node);
        node.getTypeop().apply(this);
        type = this.returnType;
        node.getIdentif().apply(this);
        identif = node.getIdentif().getText();
        node.getParametre().apply(this);
        parametre = (SaLDecVar) this.returnValue;
        node.getVarloc().apply(this);
        variable = (SaLDecVar) this.returnValue;
        node.getBlocinst().apply(this);
        bloc = (SaInst) this.returnValue;
        this.returnValue = new SaDecFonc(identif, type, parametre, variable, bloc);
        outADecfonc(node);
    }
    @Override
    public void caseAEntierType(AEntierType node)
    {
        inAEntierType(node);
        returnType = Type.ENTIER;
        outAEntierType(node);
    }
    @Override
    public void caseABooleanType(ABooleanType node)
    {
        inABooleanType(node);
        returnType = Type.BOOL;
        outABooleanType(node);
    }
    @Override
    public void caseATypeTypeop(ATypeTypeop node)
    {
        inATypeTypeop(node);
        node.getType().apply(this);
        this.returnType = Type.ENTIER ;
        outATypeTypeop(node);
    }
    @Override
    public void caseAVideTypeop(AVideTypeop node)
    {
        inAVideTypeop(node);
        returnType = Type.NUL;
        outAVideTypeop(node);
    }
    @Override
    public void caseABlocinst(ABlocinst node)
    {
        SaLInst li ;
        inABlocinst(node);
        node.getListeinst().apply(this);
        li = (SaLInst) this.returnValue;
        this.returnValue = new SaInstBloc(li);
        outABlocinst(node);
    }
    @Override
    public void caseAListeInstructionListeinst(AListeInstructionListeinst node)
    {
        SaInst instr ;
        SaLInst linstr ;
        inAListeInstructionListeinst(node);
        node.getInst().apply(this);
        instr = (SaInst) this.returnValue;
        node.getListeinst().apply(this);
        linstr =(SaLInst) this.returnValue;
        this.returnValue = new SaLInst(instr,linstr);
        outAListeInstructionListeinst(node);
    }
    @Override
    public void caseAVideListeinst(AVideListeinst node)
    {
        inAVideListeinst(node);
        this.returnValue = null;
        outAVideListeinst(node);
    }
    @Override
    public void caseAVariableInst(AVariableInst node)
    {
        SaVar lhs ;
        SaExp rhs ;
        inAVariableInst(node);
        node.getVar().apply(this);
        lhs = (SaVar) this.returnValue;
        node.getExpr().apply(this);
        rhs = (SaExp) this.returnValue;
        this.returnValue =  new SaInstAffect(lhs,rhs);

        outAVariableInst(node);
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    @Override
    public void caseAConditionSiInst(AConditionSiInst node)
    {
        SaExp test ;
        SaInst valor;
        inAConditionSiInst(node);
        node.getExpr().apply(this);
        test = (SaExp) this.returnValue;
        node.getBlocinst().apply(this);
        valor = (SaInst) this.returnValue;
        this.returnValue = new SaInstSi(test , valor , null);
        outAConditionSiInst(node);
    }
    @Override
    public void caseAConditionSinonInst(AConditionSinonInst node)
    {
        SaExp test ;
        SaInst valor ;
        SaInst sinon ;
        inAConditionSinonInst(node);
        node.getExpr().apply(this);
        test = (SaExp) this.returnValue;
        node.getBlocinstsi().apply(this);
        valor = (SaInst) this.returnValue;
        node.getBlocinstsinon().apply(this);
        sinon = (SaInst) this.returnValue;
        this.returnValue = new SaInstSi(test, valor, sinon);
        outAConditionSinonInst(node);
    }
    @Override
    public void caseAConditionTantqueInst(AConditionTantqueInst node)
    {
        SaExp test ;
        SaInst fairs;
        inAConditionTantqueInst(node);
        node.getExpr().apply(this);
        test = (SaExp) this.returnValue;
        node.getBlocinst().apply(this);
        fairs = (SaInst) this.returnValue;
        this.returnValue = new SaInstTantQue(test , fairs);
        outAConditionTantqueInst(node);
    }
    @Override
    public void caseAConditionAppelleDeFonctionInst(AConditionAppelleDeFonctionInst node)
    {
        String nom = null;
        SaLExp arguments = null;
        inAConditionAppelleDeFonctionInst(node);
        node.getIdentif().apply(this);
        nom = node.getIdentif().getText();
        node.getListeexpr().apply(this);
        arguments = (SaLExp) this.returnValue;
        this.returnValue = new SaAppel(nom , arguments);
        outAConditionAppelleDeFonctionInst(node);
    }
    @Override
    public void caseAEcrireInst(AEcrireInst node)
    {
        SaExp arg ;
        inAEcrireInst(node);
        node.getExpr().apply(this);
        arg = (SaExp) this.returnValue;
        this.returnValue = new SaInstEcriture(arg);
        outAEcrireInst(node);
    }
    @Override
    public void caseAConditionReturnInst(AConditionReturnInst node)
    {
        SaExp val ;
        inAConditionReturnInst(node);
        node.getExpr().apply(this);
        val = (SaExp) this.returnValue;
        this.returnValue = new SaInstRetour(val);
        outAConditionReturnInst(node);
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////
    @Override
    public void caseAListeExpressionListeexpr(AListeExpressionListeexpr node)
    {
        SaExp tete ;
        SaLExp queue ;
        inAListeExpressionListeexpr(node);
        node.getExpr().apply(this);
        tete = (SaExp) this.returnValue;
        node.getListeexprp().apply(this);
        queue = (SaLExp) this.returnValue;
        this.returnValue = new SaLExp(tete,queue);
        outAListeExpressionListeexpr(node);
    }
    @Override
    public void caseAVideListeexpr(AVideListeexpr node)
    {
        inAVideListeexpr(node);
        this.returnValue = null;
        outAVideListeexpr(node);
    }
    @Override
    public void caseAListeExpressionPrimeListeexprp(AListeExpressionPrimeListeexprp node)
    {
        SaExp tetep ;
        SaLExp queuep ;
        inAListeExpressionPrimeListeexprp(node);
        node.getExpr().apply(this);
        tetep = (SaExp) this.returnValue;
        node.getListeexprp().apply(this);
        queuep = (SaLExp) this.returnValue;
        this.returnValue = new SaLExp(tetep , queuep);
        outAListeExpressionPrimeListeexprp(node);
    }
    @Override
    public void caseAVideListeexprp(AVideListeexprp node)
    {
        this.returnValue = null;
    }
    @Override
    public void caseAConditionOuExpr(AConditionOuExpr node)
    {
        SaExp op1 ;
        SaExp op2 ;
        inAConditionOuExpr(node);
        node.getExpr().apply(this);
        op1 = (SaExp) this.returnValue;
        node.getExpr1().apply(this);
        op2 = (SaExp) this.returnValue;
        this.returnValue = new SaExpOr(op1,op2);
        outAConditionOuExpr(node);
    }

    @Override
    public void caseAExpr1Expr(AExpr1Expr node)
    {
        inAExpr1Expr(node);
        if(node.getExpr1() != null)
        {
            node.getExpr1().apply(this);
        }
        outAExpr1Expr(node);
    }
    @Override
    public void caseAConditionEtExpr1(AConditionEtExpr1 node)
    {
        SaExp op1 ;
        SaExp op2 ;
        node.getExpr1().apply(this);
        op1 = (SaExp) this.returnValue;
        node.getExpr2().apply(this);
        op2 = (SaExp) this.returnValue;
        this.returnValue = new SaExpAnd(op1,op2);
        outAConditionEtExpr1(node);
    }
    @Override
    public void caseAExpr2Expr1(AExpr2Expr1 node)
    {
        inAExpr2Expr1(node);
        if(node.getExpr2() != null)
        {
            node.getExpr2().apply(this);
        }
        outAExpr2Expr1(node);
    }
    @Override
    public void caseAConditionEgalExpr2(AConditionEgalExpr2 node)
    {
        SaExp op2 ;
        SaExp op3 ;
        inAConditionEgalExpr2(node);
        node.getExpr2().apply(this);
        op2 = (SaExp) this.returnValue;
        node.getExpr3().apply(this);
        op3 = (SaExp) this.returnValue;
        this.returnValue = new SaExpEqual(op2,op3);
        outAConditionEgalExpr2(node);
    }
    @Override
    public void caseAConditionInfExpr2(AConditionInfExpr2 node)
    {
        SaExp op2;
        SaExp op3;
        inAConditionInfExpr2(node);
        node.getExpr2().apply(this);
        op2 = (SaExp) this.returnValue;
        node.getExpr3().apply(this);
        op3 = (SaExp) this.returnValue;
        this.returnValue = new SaExpInf(op2,op3);
        outAConditionInfExpr2(node);
    }
    @Override
    public void caseAExpr3Expr2(AExpr3Expr2 node)
    {
        inAExpr3Expr2(node);
        if(node.getExpr3() != null)
        {
            node.getExpr3().apply(this);
        }
        outAExpr3Expr2(node);
    }
    @Override
    public void caseACondtionPlusExpr3(ACondtionPlusExpr3 node)
    {
        SaExp op3 ;
        SaExp op4 ;
        inACondtionPlusExpr3(node);
        node.getExpr3().apply(this);
        op3 = (SaExp) returnValue;
        node.getExpr4().apply(this);
        op4 = (SaExp) returnValue;
        this.returnValue = new SaExpAdd(op3,op4);
        outACondtionPlusExpr3(node);
    }
    @Override
    public void caseAConditionMoinsExpr3(AConditionMoinsExpr3 node)
    {
        inAConditionMoinsExpr3(node);
        SaExp op3 ;
        SaExp op4 ;
        inAConditionMoinsExpr3(node);
        node.getExpr3().apply(this);
        op3 = (SaExp) this.returnValue;
        node.getExpr4().apply(this);
        op4 = (SaExp) this.returnValue;
        this.returnValue = new SaExpSub(op3,op4);
        outAConditionMoinsExpr3(node);
    }
    @Override
    public void caseAExpr4Expr3(AExpr4Expr3 node)
    {
        inAExpr4Expr3(node);
        if(node.getExpr4() != null)
        {
            node.getExpr4().apply(this);
        }
        outAExpr4Expr3(node);
    }
    @Override
    public void caseAConditionMultExpr4(AConditionMultExpr4 node)
    {
        SaExp op4 ;
        SaExp op5 ;
        inAConditionMultExpr4(node);
        node.getExpr4().apply(this);
        op4 = (SaExp) this.returnValue;
        node.getExpr5().apply(this);
        op5 = (SaExp) this.returnValue;
        this.returnValue = new SaExpMult(op4,op5);
        outAConditionMultExpr4(node);
    }
    @Override
    public void caseAConditionDivExpr4(AConditionDivExpr4 node)
    {
        SaExp op4 ;
        SaExp op5 ;
        inAConditionDivExpr4(node);
        node.getExpr4().apply(this);
        op4 = (SaExp) this.returnValue;
        node.getExpr5().apply(this);
        op5 = (SaExp) this.returnValue;
        this.returnValue = new SaExpDiv(op4,op5);
        outAConditionDivExpr4(node);
    }
    @Override
    public void caseAExpr5Expr4(AExpr5Expr4 node)
    {
        inAExpr5Expr4(node);
        if(node.getExpr5() != null)
        {
            node.getExpr5().apply(this);
        }
        outAExpr5Expr4(node);
    }
    @Override
    public void caseAConditionNegationExpr5(AConditionNegationExpr5 node)
    {
        SaExp op5 ;
        inAConditionNegationExpr5(node);
        node.getExpr5().apply(this);
        op5 = (SaExp) this.returnValue;
        this.returnValue = new SaExpNot(op5);
        outAConditionNegationExpr5(node);
    }
    @Override
    public void caseAExpr6Expr5(AExpr6Expr5 node)
    {
        inAExpr6Expr5(node);
        node.getExpr6().apply(this);
        outAExpr6Expr5(node);
    }
    @Override
    public void caseAExprExpr6(AExprExpr6 node)
    {
        inAExprExpr6(node);
        node.getExpr().apply(this);
        outAExprExpr6(node);
    }
    @Override
    public void caseANombreExpr6(ANombreExpr6 node)
    {
        int nombre = 0;
        inANombreExpr6(node);
        node.getNombre().apply(this);
        nombre = Integer.parseInt(node.getNombre().getText()) ;
        this.returnValue = new SaExpInt(nombre);
        outANombreExpr6(node);
    }
    @Override
    public void caseAVraiExpr6(AVraiExpr6 node)
    {
        inAVraiExpr6(node);
        this.returnValue = new SaExpVrai();
        this.returnType = Type.BOOL;
        outAVraiExpr6(node);
    }
    @Override
    public void caseAFauxExpr6(AFauxExpr6 node)
    {
        inAFauxExpr6(node);
        this.returnValue = new SaExpFaux();
        this.returnType = Type.BOOL;
        outAFauxExpr6(node);
    }
    @Override
    public void caseAIdentifiantExpr6(AIdentifiantExpr6 node)
    {
        String identity = null;
        SaLExp lexpress = null;

        inAIdentifiantExpr6(node);
        node.getIdentif().apply(this);
        identity = node.getIdentif().getText();
        node.getListeexpr().apply(this);
        lexpress = (SaLExp) this.returnValue;
        SaAppel appel = new SaAppel(identity, lexpress);
        this.returnValue = new SaExpAppel(appel);
        outAIdentifiantExpr6(node);
    }
    @Override
    public void caseALireExpr6(ALireExpr6 node)
    {

        inALireExpr6(node);
        this.returnType = Type.ENTIER;
        outALireExpr6(node);
    }
    @Override
    public void caseAVariableExpr6(AVariableExpr6 node)
    {
        SaVar var;
        inAVariableExpr6(node);
        node.getVar().apply(this);
        var = (SaVar) this.returnValue;
        this.returnValue = new SaExpVar(var);
        outAVariableExpr6(node);
    }
    @Override
    public void caseAId1Var(AId1Var node)
    {
        String identified1;
        inAId1Var(node);
        node.getIdentif().apply(this);
        identified1 = node.getIdentif().getText();
        this.returnValue = new SaVarSimple(identified1);
        outAId1Var(node);
    }
    @Override
    public void caseAId2Var(AId2Var node)
    {
        String identifiant2;
        SaExp expressionindice;
        inAId2Var(node);
        node.getIdentif().apply(this);
        identifiant2 = node.getIdentif().getText();
        node.getExpr().apply(this);
        expressionindice = (SaExp) this.returnValue;
        this.returnValue = new SaVarIndicee(identifiant2,expressionindice);
        outAId2Var(node);
    }

    // un exemple de méthode associé à la règle
    // exp3 = {plus} exp3 plus exp4
    // //{condtion_plus} expr3 plus expr4
}
