package c3a;
import sa.*;
import ts.*;

public class Sa2c3a extends SaDepthFirstVisitor <C3aOperand> {
    private C3a c3a;
    int indentation;
    public C3a getC3a(){return this.c3a;}
    
    public Sa2c3a(SaNode root, Ts tableGlobale){
	c3a = new C3a();
	C3aTemp result = c3a.newTemp();
	C3aFunction fct = new C3aFunction(tableGlobale.getFct("main"));
	c3a.ajouteInst(new C3aInstCall(fct, result, ""));
	c3a.ajouteInst(new C3aInstStop(result, ""));
	
	indentation = 0;
	try{
	    root.accept(this);
	}
	catch(Exception e){}
    }

    @Override
    public void defaultIn(SaNode node)
    {
	//for(int i = 0; i < indentation; i++){System.out.print(" ");}
	//indentation++;
	//System.out.println("<" + node.getClass().getSimpleName() + ">");
    }

    @Override
    public void defaultOut(SaNode node)
    {
	//indentation--;
	//	for(int i = 0; i < indentation; i++){System.out.print(" ");}
	//	System.out.println("</" + node.getClass().getSimpleName() + ">");
    }
    @Override
    public C3aOperand visit(SaAppel node) throws Exception
    {
        defaultIn(node);
        C3aOperand resutat = c3a.newTemp();
        TsItemFct itemfct = node.tsItem;
        C3aFunction fonct = new C3aFunction(itemfct);
        SaLExp parametre = node.getArguments();
        while (parametre != null){
            C3aOperand operand1 = parametre.getTete().accept(this);
            c3a.ajouteInst(new C3aInstParam(operand1,"appel"));
            parametre = parametre.getQueue();
        }
        c3a.ajouteInst(new C3aInstCall(fonct, resutat , ""));
        defaultOut(node);
        return resutat;
    }
    @Override
    public C3aOperand visit(SaVarSimple node) throws Exception
    {
        defaultIn(node);
        TsItemVarSimple varSimple = node.getTsItem();
        C3aOperand result = new C3aVar(varSimple , null);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpInt node) throws Exception
    {
        defaultIn(node);
        C3aConstant result = new C3aConstant(node.getVal());
        defaultOut(node);
        return result ;
    }

    @Override
    public C3aOperand  visit(SaDecFonc node) throws Exception
    {
	defaultIn(node);
	c3a.ajouteInst(new C3aInstFBegin(node.tsItem , "entree fonction"));
    if(node.getCorps()!=null) node.getCorps().accept(this);
    c3a.ajouteInst(new C3aInstFEnd(""));

	defaultOut(node);
	return null;
    }
    @Override
    public C3aOperand visit(SaExpVrai node) throws Exception
    {
        defaultIn(node);
        C3aConstant result = new C3aConstant(1);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpFaux node) throws Exception
    {
        defaultIn(node);
        C3aConstant result = new C3aConstant(0);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpVar node) throws Exception
    {
        defaultIn(node);
        C3aOperand result =  node.getVar().accept(this);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpAppel node) throws Exception
    {
        defaultIn(node);
        C3aOperand result = node.getVal().accept(this);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaInstAffect node) throws Exception
    {
        defaultIn(node);
        C3aOperand result = node.getLhs().accept(this);
        C3aOperand partieD =  node.getRhs().accept(this);
        c3a.ajouteInst(new C3aInstAffect(partieD ,result , ""));
        defaultOut(node);
        return result;
    }

    @Override
    public C3aOperand visit(SaExpAdd node) throws Exception
    {
        defaultIn(node);
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 = node.getOp2().accept(this);
        C3aOperand result = c3a.newTemp();

        c3a.ajouteInst(new C3aInstAdd(op1 , op2 , result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpSub node) throws Exception
    {
        defaultIn(node);
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 =  node.getOp2().accept(this);
        C3aOperand result = c3a.newTemp();
        c3a.ajouteInst(new C3aInstSub(op1 , op2 , result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpMult node) throws Exception
    {
        defaultIn(node);
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 = node.getOp2().accept(this);
        C3aOperand result = c3a.newTemp();
        c3a.ajouteInst(new C3aInstMult(op1 , op2 , result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpDiv node) throws Exception
    {
        defaultIn(node);
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 = node.getOp2().accept(this);
        C3aOperand result = c3a.newTemp();

        c3a.ajouteInst(new C3aInstDiv(op1 , op2 , result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpInf node) throws Exception
    {
        defaultIn(node);
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 =node.getOp2().accept(this);
        C3aOperand result = c3a.newTemp();
        C3aLabel suite = c3a.newAutoLabel();

        c3a.ajouteInst(new C3aInstAffect(c3a.True , result , ""));//InstAffec initialiser à la valeur vrai result
        c3a.ajouteInst(new C3aInstJumpIfLess(op1 ,op2 , suite , "")); // si op1 < op2 saut au label true
        c3a.ajouteInst(new C3aInstAffect(c3a.False , result , ""));
        c3a.addLabelToNextInst(suite);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpAnd node) throws Exception
    {
        defaultIn(node);
        C3aLabel suite = c3a.newAutoLabel();
        C3aLabel faux = c3a.newAutoLabel();
        C3aOperand result = c3a.newTemp();
        C3aOperand op1 = node.getOp1().accept(this);
        c3a.ajouteInst(new C3aInstJumpIfEqual(op1 , c3a.False , faux , ""));
        C3aOperand op2 = node.getOp2().accept(this) ;
        c3a.ajouteInst(new C3aInstJumpIfEqual(op2 , c3a.False , faux , ""));
        c3a.ajouteInst(new C3aInstAffect(c3a.True , result , ""));
        c3a.ajouteInst(new C3aInstJump(suite , ""));
        c3a.addLabelToNextInst(faux);
        c3a.ajouteInst(new C3aInstAffect(c3a.False , result, ""));
        c3a.addLabelToNextInst(suite);
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpOr node) throws Exception
    {
        defaultIn(node);
        C3aLabel vrai  = c3a.newAutoLabel();
        C3aLabel suite = c3a.newAutoLabel();
        C3aOperand E_t = c3a.newTemp();
        C3aOperand E1 = node.getOp1().accept(this);
        c3a.ajouteInst(new C3aInstJumpIfNotEqual(E1 , c3a.False , suite , ""));
        C3aOperand E2 = node.getOp2().accept(this);
        c3a.ajouteInst(new C3aInstJumpIfNotEqual(E2 , c3a.False , suite , ""));
        c3a.ajouteInst(new C3aInstAffect(c3a.False , E_t , ""));
        c3a.ajouteInst(new C3aInstJump(vrai , ""));
        //l'une des expression est vraie
        c3a.addLabelToNextInst(suite);
        c3a.ajouteInst(new C3aInstAffect(c3a.True , E_t , ""));
        //Fin de l'évaluation
        c3a.addLabelToNextInst(vrai);
        defaultOut(node);
        return E_t;
    }
    @Override
    public C3aOperand visit(SaExpNot node) throws Exception
    {
        defaultIn(node);
        C3aLabel faux = c3a.newAutoLabel();
        C3aOperand result = c3a.newTemp();
        C3aOperand op = node.getOp1().accept(this);
        c3a.ajouteInst(new C3aInstAffect(c3a.True , result , ""));
        c3a.ajouteInst(new C3aInstJumpIfEqual(op , c3a.False ,faux , ""));
        c3a.ajouteInst(new C3aInstAffect(c3a.False , result , ""));

        c3a.addLabelToNextInst(faux);

        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaExpLire node) throws Exception
    {
        defaultIn(node);
        C3aOperand result = c3a.newTemp();
        c3a.ajouteInst(new C3aInstRead(result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaInstEcriture node) throws Exception
    {

        defaultIn(node);
        C3aOperand result = node.getArg().accept(this);
        c3a.ajouteInst(new C3aInstWrite(result , ""));
        defaultOut(node);
        return result;
    }
    @Override
    public C3aOperand visit(SaInstTantQue node) throws Exception
    {
        defaultIn(node);
        C3aLabel test = c3a.newAutoLabel();
        C3aLabel suite = c3a.newAutoLabel();
        c3a.addLabelToNextInst(test);
        C3aOperand E = node.getTest().accept(this);
        c3a.ajouteInst(new C3aInstJumpIfEqual(E , c3a.False , suite , ""));
        node.getFaire().accept(this);
        c3a.ajouteInst(new C3aInstJump(test , ""));
        c3a.addLabelToNextInst(suite);
        defaultOut(node);
        return null;
    }

    @Override
    public C3aOperand visit(SaInstSi node) throws Exception
    {
        defaultIn(node);
        C3aLabel suite = c3a.newAutoLabel();
        C3aLabel faux = c3a.newAutoLabel();
        //C3aOperand result = c3a.newTemp();

        C3aOperand test = node.getTest().accept(this);
        c3a.ajouteInst(new C3aInstJumpIfEqual(test , c3a.False , suite , ""));
        node.getAlors().accept(this);
        if (node.getSinon()!=null){
            c3a.ajouteInst(new C3aInstJump(faux , ""));
            c3a.addLabelToNextInst(suite);
            node.getSinon().accept(this);
            c3a.addLabelToNextInst(faux);
        }
        //c3a.ajouteInst(new C3aInstAffect(result , c3a.True , ""));
        //c3a.ajouteInst(new C3aInstJump(suite , ""));
        //c3a.addLabelToNextInst(faux);
        //node.getSinon().accept(this);
        //c3a.ajouteInst(new C3aInstAffect(result , c3a.False , ""));
        //c3a.addLabelToNextInst(suite);
        else {
            c3a.addLabelToNextInst(suite);
        }
        defaultOut(node);
        return null;
    }
    @Override
    public C3aOperand visit(SaInstRetour node) throws Exception
    {
        defaultIn(node);
        C3aOperand result = node.getVal().accept(this);
        c3a.ajouteInst(new C3aInstReturn( result ,  ""));
        c3a.ajouteInst(new C3aInstFEnd(""));
        defaultOut(node);
        return result;
    }


    @Override
    public C3aOperand visit(SaExpEqual node) throws Exception
    {
        defaultIn(node);
        C3aOperand result = c3a.newTemp();
        C3aLabel label = c3a.newAutoLabel();
        C3aOperand op1 = node.getOp1().accept(this);
        C3aOperand op2 = node.getOp2().accept(this);
        c3a.ajouteInst(new C3aInstAffect(c3a.True , result , "") );
        c3a.ajouteInst(new C3aInstJumpIfEqual(op1 , op2 , label , "" ));
        c3a.ajouteInst(new C3aInstAffect(c3a.False , result , "") );
        c3a.addLabelToNextInst(label);
        defaultOut(node);
        return result;

    }
    @Override
    public C3aOperand visit(SaLExp node) throws Exception
    {
        defaultIn(node);
        C3aOperand tete = null;
        if (node.getTete()!=null){
            tete = node.getTete().accept(this);
        }
        if(node.getQueue() != null){
            node.getQueue().accept(this);
        }
        defaultOut(node);
        return tete;
    }
    @Override
    public C3aOperand visit(SaVarIndicee node) throws Exception
    {
        defaultIn(node);
        TsItemVar tsItemVar = node.tsItem;
        C3aOperand indices = node.getIndice().accept(this);
        C3aOperand res = new C3aVar(tsItemVar , indices );
        defaultOut(node);
        return res;
    }

}
