package fg;
import util.graph.*;
import nasm.*;
import util.intset.*;
import java.io.*;
import java.util.*;

public class FgSolution{
    int iterNum = 0;
    public Nasm nasm;
    Fg fg;
    public Map< NasmInst, IntSet> use;
    public Map< NasmInst, IntSet> def;
    public Map< NasmInst, IntSet> in;
    public Map< NasmInst, IntSet> out;

    
    public FgSolution(Nasm nasm, Fg fg){
	/* ... */
		this.nasm = nasm;
		this.fg = fg;
		this.use = new HashMap< NasmInst, IntSet>();
		this.def = new HashMap< NasmInst, IntSet>();
		this.in =  new HashMap< NasmInst, IntSet>();
		this.out = new HashMap< NasmInst, IntSet>();
		FgSolve();
    }
    
    public void FgSolve()
    {
		for(NasmInst nasmInst : nasm.sectionText){
			use.put(nasmInst,new IntSet((nasm.getTempCounter())));
			def.put(nasmInst,new IntSet(nasm.getTempCounter()));

			if(nasmInst.destination != null){
				if(nasmInst.destination.isGeneralRegister()){
					if(nasmInst.destUse) use.get(nasmInst).add(((NasmRegister) nasmInst.destination).val);
					if(nasmInst.destDef) def.get(nasmInst).add(((NasmRegister) nasmInst.destination).val);
				}
				else if(nasmInst.destination instanceof NasmAddress){
					NasmAddress addr = (NasmAddress) nasmInst.destination;
					if(addr.base.isGeneralRegister()) use.get(nasmInst).add(((NasmRegister) addr.base).val);
					if(addr.offset.isGeneralRegister()) use.get(nasmInst).add(((NasmRegister) addr.offset).val);
				}
			}
			if(nasmInst.source != null){
				if(nasmInst.source.isGeneralRegister()){
					if(nasmInst.srcUse) use.get(nasmInst).add(((NasmRegister) nasmInst.source).val);
					if(nasmInst.srcDef) def.get(nasmInst).add(((NasmRegister) nasmInst.source).val);
				}
				else if(nasmInst.source instanceof NasmAddress){
					NasmAddress addr = (NasmAddress) nasmInst.source;
					if(addr.base.isGeneralRegister()) use.get(nasmInst).add(((NasmRegister) addr.base).val);
					if(addr.offset.isGeneralRegister()) use.get(nasmInst).add(((NasmRegister) addr.offset).val);
				}

			}
			in.put(nasmInst , use.get(nasmInst).copy());
			out.put(nasmInst , new IntSet(nasm.getTempCounter()));
		}
	/* ... */
    boolean change;
	do{
		change = false;
		for(int i = nasm.sectionText.size()-1 ; i >= 0 ; i--){
			NasmInst nasmInst = nasm.sectionText.get(i);
			IntSet inprime = in.get(nasmInst).copy();
			IntSet outprime = out.get(nasmInst).copy();
			NodeList succp = fg.inst2Node.get(nasmInst).succ();
			/////// out(n)
			while(succp != null){
				out.get(nasmInst).union(in.get(fg.node2Inst.get(succp.head)));
				succp = succp.tail;
			}
			/////in(s)
			IntSet outMinusDef = out.get(nasmInst).copy().minus(def.get(nasmInst));
			in.get(nasmInst).union(outMinusDef);
			if(!(in.get(nasmInst).equal(inprime) && out.get(nasmInst).equal(outprime))) change = true;

		}

	}while(change);


	}

    public void affiche(String baseFileName){
	String fileName;
	PrintStream out = System.out;

	if (baseFileName != null){
	    try {
		baseFileName = baseFileName;
		fileName = baseFileName + ".fgs";
		out = new PrintStream(fileName);
	    }
	    
	    catch (IOException e) {
		System.err.println("Error: " + e.getMessage());
	    }
	}
	
	out.println("iter num = " + iterNum);
	for(NasmInst nasmInst : this.nasm.sectionText){

	    out.println("use = "+ this.use.get(nasmInst) + " def = "+ this.def.get(nasmInst) + "\tin = " + this.in.get(nasmInst) + "\t \tout = " + this.out.get(nasmInst) + "\t \t" + nasmInst);
	}
	
    }

}
