package ig;

import fg.*;
import nasm.*;
import util.graph.*;
import util.intset.*;
import java.util.*;
import java.io.*;

public class Ig {
    public Graph graph;
    public FgSolution fgs;
    public int regNb;
    public Nasm nasm;
    public Node int2Node[];
    
    
    public Ig(FgSolution fgs){
	this.fgs = fgs;
 	this.graph = new Graph();
	this.nasm = fgs.nasm;
	this.regNb = this.nasm.getTempCounter();
	this.int2Node = new Node[regNb];
	this.build();
    }
    

	public void build() {

		 for(int i =0; i<regNb; i++){
			int2Node[i] = graph.newNode();
		}
		for (int i= 0  ; i<nasm.sectionText.size();i++){
			NasmInst inst = nasm.sectionText.get(i);
			int inInsetSize = fgs.in.get(inst).getSize();
			if (!fgs.in.get(inst).isEmpty()){
				for (int r = 0;r<inInsetSize;r++){
					for (int r1 = 0; r1<inInsetSize;r1++){
						if(r != r1 && fgs.in.get(inst).isMember(r) && fgs.in.get(inst).isMember(r1)){
							graph.addNOEdge(int2Node[r],int2Node[r1]);
						}

					}
				}
			}
			int outsetSize = fgs.out.get(inst).getSize();
			if(!fgs.out.get(inst).isEmpty()) {

				for (int r = 0; r < outsetSize; r++) {

					for (int r1 = 0; r1 < outsetSize; r1++) {
						if (r != r1 && fgs.out.get(inst).isMember(r) && fgs.out.get(inst).isMember(r1)) {
							graph.addNOEdge(int2Node[r], int2Node[r1]);
						}

					}
				}
			}
		}



	}

	public int[] getPrecoloredTemporaire(){
		int[] color = new int[regNb];
		for(NasmInst nasmInst : nasm.sectionText){
			if(nasmInst.destination != null && nasmInst.destination.isGeneralRegister()){
				NasmRegister reg = (NasmRegister) nasmInst.destination;
				color[reg.val] = reg.color;
			}
			if(nasmInst.source != null && nasmInst.source.isGeneralRegister()){
				NasmRegister reg = (NasmRegister) nasmInst.source;
				color[reg.val] = reg.color;
			}
		}
		return color;
	}

	public void allocateRegisters(){
		ColorGraph colorGraph = new ColorGraph(graph , 4 , getPrecoloredTemporaire());
		colorGraph.color();
		for(NasmInst nasmInst : nasm.sectionText){
			if(nasmInst.source != null && nasmInst.source.isGeneralRegister()){
				NasmRegister reg = (NasmRegister) nasmInst.source;
				reg.colorRegister(colorGraph.color[reg.val]);
			}
			if(nasmInst.destination != null && nasmInst.destination.isGeneralRegister()){
				NasmRegister reg = (NasmRegister) nasmInst.destination;
				reg.colorRegister(colorGraph.color[reg.val]);
			}
		}
    }


    public void affiche(String baseFileName){
	String fileName;
	PrintStream out = System.out;
	
	if (baseFileName != null){
	    try {
		baseFileName = baseFileName;
		fileName = baseFileName + ".ig";
		out = new PrintStream(fileName);
	    }
	    
	    catch (IOException e) {
		System.err.println("Error: " + e.getMessage());
	    }
	}
	
	for(int i = 0; i < regNb; i++){
	    Node n = this.int2Node[i];
	    out.print(n + " : ( ");
	    for(NodeList q=n.succ(); q!=null; q=q.tail) {
		out.print(q.head.toString());
		out.print(" ");
	    }
	    out.println(")");
	}
    }
}
	    
    

    
    
