/* This file was generated by SableCC (http://www.sablecc.org/). */

package sc.parser;

import sc.lexer.*;
import sc.node.*;
import sc.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList<Object> nodeList;

    private final Lexer lexer;
    private final ListIterator<Object> stack = new LinkedList<Object>().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    @SuppressWarnings({"unchecked","unused"})
    private void push(int numstate, ArrayList<Object> listNode) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            // int middle = (low + high) / 2;
            int middle = (low + high) >>> 1;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList<Object> pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList<Object> list = new ArrayList<Object>();
		        list.add(this.lexer.next());
                        push(this.action[1], list);
                    }
		    break;
                case REDUCE:
                    {
                        int reduction = this.action[1];
                        if(reduction < 500) reduce_0(reduction);
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PProgramme node1 = (PProgramme) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }

    private void reduce_0(int reduction) throws IOException, LexerException, ParserException
    {
        switch(reduction)
        {
            case 0: /* reduce AListeDesVariables1Programme */
            {
                ArrayList<Object> list = new0();
                push(goTo(0), list);
            }
            break;
            case 1: /* reduce AVide1Programme */
            {
                ArrayList<Object> list = new1();
                push(goTo(0), list);
            }
            break;
            case 2: /* reduce AListeDesVariablesPrimeListedecvarp */
            {
                ArrayList<Object> list = new2();
                push(goTo(1), list);
            }
            break;
            case 3: /* reduce AVideListedecvarp */
            {
                ArrayList<Object> list = new3();
                push(goTo(1), list);
            }
            break;
            case 4: /* reduce AType1Decvar */
            {
                ArrayList<Object> list = new4();
                push(goTo(2), list);
            }
            break;
            case 5: /* reduce AType2Decvar */
            {
                ArrayList<Object> list = new5();
                push(goTo(2), list);
            }
            break;
            case 6: /* reduce AListeDesFonctionsListedecfonc */
            {
                ArrayList<Object> list = new6();
                push(goTo(3), list);
            }
            break;
            case 7: /* reduce AVideListedecfonc */
            {
                ArrayList<Object> list = new7();
                push(goTo(3), list);
            }
            break;
            case 8: /* reduce AListeDesVariables1$ListeDesVariables2$Type1Decfonc */
            {
                ArrayList<Object> list = new8();
                push(goTo(4), list);
            }
            break;
            case 9: /* reduce AListeDesVariables1$ListeDesVariables2$Vide1Decfonc */
            {
                ArrayList<Object> list = new9();
                push(goTo(4), list);
            }
            break;
            case 10: /* reduce AListeDesVariables1$Vide2$Type1Decfonc */
            {
                ArrayList<Object> list = new10();
                push(goTo(4), list);
            }
            break;
            case 11: /* reduce AListeDesVariables1$Vide2$Vide1Decfonc */
            {
                ArrayList<Object> list = new11();
                push(goTo(4), list);
            }
            break;
            case 12: /* reduce AVide1$ListeDesVariables2$Type1Decfonc */
            {
                ArrayList<Object> list = new12();
                push(goTo(4), list);
            }
            break;
            case 13: /* reduce AVide1$ListeDesVariables2$Vide1Decfonc */
            {
                ArrayList<Object> list = new13();
                push(goTo(4), list);
            }
            break;
            case 14: /* reduce AVide1$Vide2$Type1Decfonc */
            {
                ArrayList<Object> list = new14();
                push(goTo(4), list);
            }
            break;
            case 15: /* reduce AVide1$Vide2$Vide1Decfonc */
            {
                ArrayList<Object> list = new15();
                push(goTo(4), list);
            }
            break;
            case 16: /* reduce AEntierType */
            {
                ArrayList<Object> list = new16();
                push(goTo(5), list);
            }
            break;
            case 17: /* reduce ABooleanType */
            {
                ArrayList<Object> list = new17();
                push(goTo(5), list);
            }
            break;
            case 18: /* reduce ABlocinst */
            {
                ArrayList<Object> list = new18();
                push(goTo(6), list);
            }
            break;
            case 19: /* reduce AListeInstructionListeinst */
            {
                ArrayList<Object> list = new19();
                push(goTo(7), list);
            }
            break;
            case 20: /* reduce AVideListeinst */
            {
                ArrayList<Object> list = new20();
                push(goTo(7), list);
            }
            break;
            case 21: /* reduce AVariableInst */
            {
                ArrayList<Object> list = new21();
                push(goTo(8), list);
            }
            break;
            case 22: /* reduce AConditionSiInst */
            {
                ArrayList<Object> list = new22();
                push(goTo(8), list);
            }
            break;
            case 23: /* reduce AConditionSinonInst */
            {
                ArrayList<Object> list = new23();
                push(goTo(8), list);
            }
            break;
            case 24: /* reduce AConditionTantqueInst */
            {
                ArrayList<Object> list = new24();
                push(goTo(8), list);
            }
            break;
            case 25: /* reduce AConditionAppelleDeFonctionInst */
            {
                ArrayList<Object> list = new25();
                push(goTo(8), list);
            }
            break;
            case 26: /* reduce AEcrireInst */
            {
                ArrayList<Object> list = new26();
                push(goTo(8), list);
            }
            break;
            case 27: /* reduce AConditionReturnInst */
            {
                ArrayList<Object> list = new27();
                push(goTo(8), list);
            }
            break;
            case 28: /* reduce AListeExpressionListeexpr */
            {
                ArrayList<Object> list = new28();
                push(goTo(9), list);
            }
            break;
            case 29: /* reduce AVideListeexpr */
            {
                ArrayList<Object> list = new29();
                push(goTo(9), list);
            }
            break;
            case 30: /* reduce AListeExpressionPrimeListeexprp */
            {
                ArrayList<Object> list = new30();
                push(goTo(10), list);
            }
            break;
            case 31: /* reduce AVideListeexprp */
            {
                ArrayList<Object> list = new31();
                push(goTo(10), list);
            }
            break;
            case 32: /* reduce AConditionOuExpr */
            {
                ArrayList<Object> list = new32();
                push(goTo(11), list);
            }
            break;
            case 33: /* reduce AExpr1Expr */
            {
                ArrayList<Object> list = new33();
                push(goTo(11), list);
            }
            break;
            case 34: /* reduce AConditionEtExpr1 */
            {
                ArrayList<Object> list = new34();
                push(goTo(12), list);
            }
            break;
            case 35: /* reduce AExpr2Expr1 */
            {
                ArrayList<Object> list = new35();
                push(goTo(12), list);
            }
            break;
            case 36: /* reduce AConditionEgalExpr2 */
            {
                ArrayList<Object> list = new36();
                push(goTo(13), list);
            }
            break;
            case 37: /* reduce AConditionInfExpr2 */
            {
                ArrayList<Object> list = new37();
                push(goTo(13), list);
            }
            break;
            case 38: /* reduce AExpr3Expr2 */
            {
                ArrayList<Object> list = new38();
                push(goTo(13), list);
            }
            break;
            case 39: /* reduce ACondtionPlusExpr3 */
            {
                ArrayList<Object> list = new39();
                push(goTo(14), list);
            }
            break;
            case 40: /* reduce AConditionMoinsExpr3 */
            {
                ArrayList<Object> list = new40();
                push(goTo(14), list);
            }
            break;
            case 41: /* reduce AExpr4Expr3 */
            {
                ArrayList<Object> list = new41();
                push(goTo(14), list);
            }
            break;
            case 42: /* reduce AConditionMultExpr4 */
            {
                ArrayList<Object> list = new42();
                push(goTo(15), list);
            }
            break;
            case 43: /* reduce AConditionDivExpr4 */
            {
                ArrayList<Object> list = new43();
                push(goTo(15), list);
            }
            break;
            case 44: /* reduce AExpr5Expr4 */
            {
                ArrayList<Object> list = new44();
                push(goTo(15), list);
            }
            break;
            case 45: /* reduce AConditionNegationExpr5 */
            {
                ArrayList<Object> list = new45();
                push(goTo(16), list);
            }
            break;
            case 46: /* reduce AExpr6Expr5 */
            {
                ArrayList<Object> list = new46();
                push(goTo(16), list);
            }
            break;
            case 47: /* reduce AExprExpr6 */
            {
                ArrayList<Object> list = new47();
                push(goTo(17), list);
            }
            break;
            case 48: /* reduce ANombreExpr6 */
            {
                ArrayList<Object> list = new48();
                push(goTo(17), list);
            }
            break;
            case 49: /* reduce AVraiExpr6 */
            {
                ArrayList<Object> list = new49();
                push(goTo(17), list);
            }
            break;
            case 50: /* reduce AFauxExpr6 */
            {
                ArrayList<Object> list = new50();
                push(goTo(17), list);
            }
            break;
            case 51: /* reduce AIdentifiantExpr6 */
            {
                ArrayList<Object> list = new51();
                push(goTo(17), list);
            }
            break;
            case 52: /* reduce ALireExpr6 */
            {
                ArrayList<Object> list = new52();
                push(goTo(17), list);
            }
            break;
            case 53: /* reduce AVariableExpr6 */
            {
                ArrayList<Object> list = new53();
                push(goTo(17), list);
            }
            break;
            case 54: /* reduce AId1Var */
            {
                ArrayList<Object> list = new54();
                push(goTo(18), list);
            }
            break;
            case 55: /* reduce AId2Var */
            {
                ArrayList<Object> list = new55();
                push(goTo(18), list);
            }
            break;
        }
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new0() /* reduce AListeDesVariables1Programme */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PProgramme pprogrammeNode1;
        {
            // Block
        PListedecvar plistedecvarNode2;
        PListedecfonc plistedecfoncNode5;
        {
            // Block
        PDecvar pdecvarNode3;
        PListedecvarp plistedecvarpNode4;
        pdecvarNode3 = (PDecvar)nodeArrayList1.get(0);
        plistedecvarpNode4 = (PListedecvarp)nodeArrayList2.get(0);

        plistedecvarNode2 = new AListeDesVariablesListedecvar(pdecvarNode3, plistedecvarpNode4);
        }
        plistedecfoncNode5 = (PListedecfonc)nodeArrayList3.get(0);

        pprogrammeNode1 = new AProgramme(plistedecvarNode2, plistedecfoncNode5);
        }
	nodeList.add(pprogrammeNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new1() /* reduce AVide1Programme */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PProgramme pprogrammeNode1;
        {
            // Block
        PListedecvar plistedecvarNode2;
        PListedecfonc plistedecfoncNode3;
        {
            // Block

        plistedecvarNode2 = new AVideListedecvar();
        }
        plistedecfoncNode3 = (PListedecfonc)nodeArrayList1.get(0);

        pprogrammeNode1 = new AProgramme(plistedecvarNode2, plistedecfoncNode3);
        }
	nodeList.add(pprogrammeNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new2() /* reduce AListeDesVariablesPrimeListedecvarp */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PListedecvarp plistedecvarpNode1;
        {
            // Block
        TVirgule tvirguleNode2;
        PDecvar pdecvarNode3;
        PListedecvarp plistedecvarpNode4;
        tvirguleNode2 = (TVirgule)nodeArrayList1.get(0);
        pdecvarNode3 = (PDecvar)nodeArrayList2.get(0);
        plistedecvarpNode4 = (PListedecvarp)nodeArrayList3.get(0);

        plistedecvarpNode1 = new AListeDesVariablesPrimeListedecvarp(tvirguleNode2, pdecvarNode3, plistedecvarpNode4);
        }
	nodeList.add(plistedecvarpNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new3() /* reduce AVideListedecvarp */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        PListedecvarp plistedecvarpNode1;
        {
            // Block

        plistedecvarpNode1 = new AVideListedecvarp();
        }
	nodeList.add(plistedecvarpNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new4() /* reduce AType1Decvar */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecvar pdecvarNode1;
        {
            // Block
        PType ptypeNode2;
        TIdentif tidentifNode3;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        tidentifNode3 = (TIdentif)nodeArrayList2.get(0);

        pdecvarNode1 = new AType1Decvar(ptypeNode2, tidentifNode3);
        }
	nodeList.add(pdecvarNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new5() /* reduce AType2Decvar */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecvar pdecvarNode1;
        {
            // Block
        PType ptypeNode2;
        TIdentif tidentifNode3;
        TCrochetouvrant tcrochetouvrantNode4;
        TNombre tnombreNode5;
        TCrochetfermant tcrochetfermantNode6;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        tidentifNode3 = (TIdentif)nodeArrayList2.get(0);
        tcrochetouvrantNode4 = (TCrochetouvrant)nodeArrayList3.get(0);
        tnombreNode5 = (TNombre)nodeArrayList4.get(0);
        tcrochetfermantNode6 = (TCrochetfermant)nodeArrayList5.get(0);

        pdecvarNode1 = new AType2Decvar(ptypeNode2, tidentifNode3, tcrochetouvrantNode4, tnombreNode5, tcrochetfermantNode6);
        }
	nodeList.add(pdecvarNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new6() /* reduce AListeDesFonctionsListedecfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PListedecfonc plistedecfoncNode1;
        {
            // Block
        PDecfonc pdecfoncNode2;
        PListedecfonc plistedecfoncNode3;
        pdecfoncNode2 = (PDecfonc)nodeArrayList1.get(0);
        plistedecfoncNode3 = (PListedecfonc)nodeArrayList2.get(0);

        plistedecfoncNode1 = new AListeDesFonctionsListedecfonc(pdecfoncNode2, plistedecfoncNode3);
        }
	nodeList.add(plistedecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new7() /* reduce AVideListedecfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        PListedecfonc plistedecfoncNode1;
        {
            // Block

        plistedecfoncNode1 = new AVideListedecfonc();
        }
	nodeList.add(plistedecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new8() /* reduce AListeDesVariables1$ListeDesVariables2$Type1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode4;
        TParenthouvrante tparenthouvranteNode5;
        PListedecvar plistedecvarNode6;
        TParenthfermante tparenthfermanteNode9;
        PListedecvar plistedecvarNode10;
        PBlocinst pblocinstNode13;
        {
            // Block
        PType ptypeNode3;
        ptypeNode3 = (PType)nodeArrayList1.get(0);

        ptypeopNode2 = new ATypeTypeop(ptypeNode3);
        }
        tidentifNode4 = (TIdentif)nodeArrayList2.get(0);
        tparenthouvranteNode5 = (TParenthouvrante)nodeArrayList3.get(0);
        {
            // Block
        PDecvar pdecvarNode7;
        PListedecvarp plistedecvarpNode8;
        pdecvarNode7 = (PDecvar)nodeArrayList4.get(0);
        plistedecvarpNode8 = (PListedecvarp)nodeArrayList5.get(0);

        plistedecvarNode6 = new AListeDesVariablesListedecvar(pdecvarNode7, plistedecvarpNode8);
        }
        tparenthfermanteNode9 = (TParenthfermante)nodeArrayList6.get(0);
        {
            // Block
        PDecvar pdecvarNode11;
        PListedecvarp plistedecvarpNode12;
        pdecvarNode11 = (PDecvar)nodeArrayList7.get(0);
        plistedecvarpNode12 = (PListedecvarp)nodeArrayList8.get(0);

        plistedecvarNode10 = new AListeDesVariablesListedecvar(pdecvarNode11, plistedecvarpNode12);
        }
        pblocinstNode13 = (PBlocinst)nodeArrayList9.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode4, tparenthouvranteNode5, plistedecvarNode6, tparenthfermanteNode9, plistedecvarNode10, pblocinstNode13);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new9() /* reduce AListeDesVariables1$ListeDesVariables2$Vide1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode3;
        TParenthouvrante tparenthouvranteNode4;
        PListedecvar plistedecvarNode5;
        TParenthfermante tparenthfermanteNode8;
        PListedecvar plistedecvarNode9;
        PBlocinst pblocinstNode12;
        {
            // Block

        ptypeopNode2 = new AVideTypeop();
        }
        tidentifNode3 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode4 = (TParenthouvrante)nodeArrayList2.get(0);
        {
            // Block
        PDecvar pdecvarNode6;
        PListedecvarp plistedecvarpNode7;
        pdecvarNode6 = (PDecvar)nodeArrayList3.get(0);
        plistedecvarpNode7 = (PListedecvarp)nodeArrayList4.get(0);

        plistedecvarNode5 = new AListeDesVariablesListedecvar(pdecvarNode6, plistedecvarpNode7);
        }
        tparenthfermanteNode8 = (TParenthfermante)nodeArrayList5.get(0);
        {
            // Block
        PDecvar pdecvarNode10;
        PListedecvarp plistedecvarpNode11;
        pdecvarNode10 = (PDecvar)nodeArrayList6.get(0);
        plistedecvarpNode11 = (PListedecvarp)nodeArrayList7.get(0);

        plistedecvarNode9 = new AListeDesVariablesListedecvar(pdecvarNode10, plistedecvarpNode11);
        }
        pblocinstNode12 = (PBlocinst)nodeArrayList8.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode3, tparenthouvranteNode4, plistedecvarNode5, tparenthfermanteNode8, plistedecvarNode9, pblocinstNode12);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new10() /* reduce AListeDesVariables1$Vide2$Type1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode4;
        TParenthouvrante tparenthouvranteNode5;
        PListedecvar plistedecvarNode6;
        TParenthfermante tparenthfermanteNode9;
        PListedecvar plistedecvarNode10;
        PBlocinst pblocinstNode11;
        {
            // Block
        PType ptypeNode3;
        ptypeNode3 = (PType)nodeArrayList1.get(0);

        ptypeopNode2 = new ATypeTypeop(ptypeNode3);
        }
        tidentifNode4 = (TIdentif)nodeArrayList2.get(0);
        tparenthouvranteNode5 = (TParenthouvrante)nodeArrayList3.get(0);
        {
            // Block
        PDecvar pdecvarNode7;
        PListedecvarp plistedecvarpNode8;
        pdecvarNode7 = (PDecvar)nodeArrayList4.get(0);
        plistedecvarpNode8 = (PListedecvarp)nodeArrayList5.get(0);

        plistedecvarNode6 = new AListeDesVariablesListedecvar(pdecvarNode7, plistedecvarpNode8);
        }
        tparenthfermanteNode9 = (TParenthfermante)nodeArrayList6.get(0);
        {
            // Block

        plistedecvarNode10 = new AVideListedecvar();
        }
        pblocinstNode11 = (PBlocinst)nodeArrayList7.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode4, tparenthouvranteNode5, plistedecvarNode6, tparenthfermanteNode9, plistedecvarNode10, pblocinstNode11);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new11() /* reduce AListeDesVariables1$Vide2$Vide1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode3;
        TParenthouvrante tparenthouvranteNode4;
        PListedecvar plistedecvarNode5;
        TParenthfermante tparenthfermanteNode8;
        PListedecvar plistedecvarNode9;
        PBlocinst pblocinstNode10;
        {
            // Block

        ptypeopNode2 = new AVideTypeop();
        }
        tidentifNode3 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode4 = (TParenthouvrante)nodeArrayList2.get(0);
        {
            // Block
        PDecvar pdecvarNode6;
        PListedecvarp plistedecvarpNode7;
        pdecvarNode6 = (PDecvar)nodeArrayList3.get(0);
        plistedecvarpNode7 = (PListedecvarp)nodeArrayList4.get(0);

        plistedecvarNode5 = new AListeDesVariablesListedecvar(pdecvarNode6, plistedecvarpNode7);
        }
        tparenthfermanteNode8 = (TParenthfermante)nodeArrayList5.get(0);
        {
            // Block

        plistedecvarNode9 = new AVideListedecvar();
        }
        pblocinstNode10 = (PBlocinst)nodeArrayList6.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode3, tparenthouvranteNode4, plistedecvarNode5, tparenthfermanteNode8, plistedecvarNode9, pblocinstNode10);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new12() /* reduce AVide1$ListeDesVariables2$Type1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode4;
        TParenthouvrante tparenthouvranteNode5;
        PListedecvar plistedecvarNode6;
        TParenthfermante tparenthfermanteNode7;
        PListedecvar plistedecvarNode8;
        PBlocinst pblocinstNode11;
        {
            // Block
        PType ptypeNode3;
        ptypeNode3 = (PType)nodeArrayList1.get(0);

        ptypeopNode2 = new ATypeTypeop(ptypeNode3);
        }
        tidentifNode4 = (TIdentif)nodeArrayList2.get(0);
        tparenthouvranteNode5 = (TParenthouvrante)nodeArrayList3.get(0);
        {
            // Block

        plistedecvarNode6 = new AVideListedecvar();
        }
        tparenthfermanteNode7 = (TParenthfermante)nodeArrayList4.get(0);
        {
            // Block
        PDecvar pdecvarNode9;
        PListedecvarp plistedecvarpNode10;
        pdecvarNode9 = (PDecvar)nodeArrayList5.get(0);
        plistedecvarpNode10 = (PListedecvarp)nodeArrayList6.get(0);

        plistedecvarNode8 = new AListeDesVariablesListedecvar(pdecvarNode9, plistedecvarpNode10);
        }
        pblocinstNode11 = (PBlocinst)nodeArrayList7.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode4, tparenthouvranteNode5, plistedecvarNode6, tparenthfermanteNode7, plistedecvarNode8, pblocinstNode11);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new13() /* reduce AVide1$ListeDesVariables2$Vide1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode3;
        TParenthouvrante tparenthouvranteNode4;
        PListedecvar plistedecvarNode5;
        TParenthfermante tparenthfermanteNode6;
        PListedecvar plistedecvarNode7;
        PBlocinst pblocinstNode10;
        {
            // Block

        ptypeopNode2 = new AVideTypeop();
        }
        tidentifNode3 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode4 = (TParenthouvrante)nodeArrayList2.get(0);
        {
            // Block

        plistedecvarNode5 = new AVideListedecvar();
        }
        tparenthfermanteNode6 = (TParenthfermante)nodeArrayList3.get(0);
        {
            // Block
        PDecvar pdecvarNode8;
        PListedecvarp plistedecvarpNode9;
        pdecvarNode8 = (PDecvar)nodeArrayList4.get(0);
        plistedecvarpNode9 = (PListedecvarp)nodeArrayList5.get(0);

        plistedecvarNode7 = new AListeDesVariablesListedecvar(pdecvarNode8, plistedecvarpNode9);
        }
        pblocinstNode10 = (PBlocinst)nodeArrayList6.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode3, tparenthouvranteNode4, plistedecvarNode5, tparenthfermanteNode6, plistedecvarNode7, pblocinstNode10);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new14() /* reduce AVide1$Vide2$Type1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode4;
        TParenthouvrante tparenthouvranteNode5;
        PListedecvar plistedecvarNode6;
        TParenthfermante tparenthfermanteNode7;
        PListedecvar plistedecvarNode8;
        PBlocinst pblocinstNode9;
        {
            // Block
        PType ptypeNode3;
        ptypeNode3 = (PType)nodeArrayList1.get(0);

        ptypeopNode2 = new ATypeTypeop(ptypeNode3);
        }
        tidentifNode4 = (TIdentif)nodeArrayList2.get(0);
        tparenthouvranteNode5 = (TParenthouvrante)nodeArrayList3.get(0);
        {
            // Block

        plistedecvarNode6 = new AVideListedecvar();
        }
        tparenthfermanteNode7 = (TParenthfermante)nodeArrayList4.get(0);
        {
            // Block

        plistedecvarNode8 = new AVideListedecvar();
        }
        pblocinstNode9 = (PBlocinst)nodeArrayList5.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode4, tparenthouvranteNode5, plistedecvarNode6, tparenthfermanteNode7, plistedecvarNode8, pblocinstNode9);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new15() /* reduce AVide1$Vide2$Vide1Decfonc */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PDecfonc pdecfoncNode1;
        {
            // Block
        PTypeop ptypeopNode2;
        TIdentif tidentifNode3;
        TParenthouvrante tparenthouvranteNode4;
        PListedecvar plistedecvarNode5;
        TParenthfermante tparenthfermanteNode6;
        PListedecvar plistedecvarNode7;
        PBlocinst pblocinstNode8;
        {
            // Block

        ptypeopNode2 = new AVideTypeop();
        }
        tidentifNode3 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode4 = (TParenthouvrante)nodeArrayList2.get(0);
        {
            // Block

        plistedecvarNode5 = new AVideListedecvar();
        }
        tparenthfermanteNode6 = (TParenthfermante)nodeArrayList3.get(0);
        {
            // Block

        plistedecvarNode7 = new AVideListedecvar();
        }
        pblocinstNode8 = (PBlocinst)nodeArrayList4.get(0);

        pdecfoncNode1 = new ADecfonc(ptypeopNode2, tidentifNode3, tparenthouvranteNode4, plistedecvarNode5, tparenthfermanteNode6, plistedecvarNode7, pblocinstNode8);
        }
	nodeList.add(pdecfoncNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new16() /* reduce AEntierType */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TEntier tentierNode2;
        tentierNode2 = (TEntier)nodeArrayList1.get(0);

        ptypeNode1 = new AEntierType(tentierNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new17() /* reduce ABooleanType */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TBool tboolNode2;
        tboolNode2 = (TBool)nodeArrayList1.get(0);

        ptypeNode1 = new ABooleanType(tboolNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new18() /* reduce ABlocinst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PBlocinst pblocinstNode1;
        {
            // Block
        TAccolateouvrant taccolateouvrantNode2;
        PListeinst plisteinstNode3;
        TAccolatefermant taccolatefermantNode4;
        taccolateouvrantNode2 = (TAccolateouvrant)nodeArrayList1.get(0);
        plisteinstNode3 = (PListeinst)nodeArrayList2.get(0);
        taccolatefermantNode4 = (TAccolatefermant)nodeArrayList3.get(0);

        pblocinstNode1 = new ABlocinst(taccolateouvrantNode2, plisteinstNode3, taccolatefermantNode4);
        }
	nodeList.add(pblocinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new19() /* reduce AListeInstructionListeinst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PListeinst plisteinstNode1;
        {
            // Block
        PInst pinstNode2;
        PListeinst plisteinstNode3;
        pinstNode2 = (PInst)nodeArrayList1.get(0);
        plisteinstNode3 = (PListeinst)nodeArrayList2.get(0);

        plisteinstNode1 = new AListeInstructionListeinst(pinstNode2, plisteinstNode3);
        }
	nodeList.add(plisteinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new20() /* reduce AVideListeinst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        PListeinst plisteinstNode1;
        {
            // Block

        plisteinstNode1 = new AVideListeinst();
        }
	nodeList.add(plisteinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new21() /* reduce AVariableInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        PVar pvarNode2;
        TEgal tegalNode3;
        PExpr pexprNode4;
        TPtvirgule tptvirguleNode5;
        pvarNode2 = (PVar)nodeArrayList1.get(0);
        tegalNode3 = (TEgal)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tptvirguleNode5 = (TPtvirgule)nodeArrayList4.get(0);

        pinstNode1 = new AVariableInst(pvarNode2, tegalNode3, pexprNode4, tptvirguleNode5);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new22() /* reduce AConditionSiInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TSi tsiNode2;
        PExpr pexprNode3;
        TAlors talorsNode4;
        PBlocinst pblocinstNode5;
        tsiNode2 = (TSi)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        talorsNode4 = (TAlors)nodeArrayList3.get(0);
        pblocinstNode5 = (PBlocinst)nodeArrayList4.get(0);

        pinstNode1 = new AConditionSiInst(tsiNode2, pexprNode3, talorsNode4, pblocinstNode5);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new23() /* reduce AConditionSinonInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TSi tsiNode2;
        PExpr pexprNode3;
        TAlors talorsNode4;
        PBlocinst pblocinstNode5;
        TSinon tsinonNode6;
        PBlocinst pblocinstNode7;
        tsiNode2 = (TSi)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        talorsNode4 = (TAlors)nodeArrayList3.get(0);
        pblocinstNode5 = (PBlocinst)nodeArrayList4.get(0);
        tsinonNode6 = (TSinon)nodeArrayList5.get(0);
        pblocinstNode7 = (PBlocinst)nodeArrayList6.get(0);

        pinstNode1 = new AConditionSinonInst(tsiNode2, pexprNode3, talorsNode4, pblocinstNode5, tsinonNode6, pblocinstNode7);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new24() /* reduce AConditionTantqueInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TTantque ttantqueNode2;
        PExpr pexprNode3;
        TFaire tfaireNode4;
        PBlocinst pblocinstNode5;
        ttantqueNode2 = (TTantque)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tfaireNode4 = (TFaire)nodeArrayList3.get(0);
        pblocinstNode5 = (PBlocinst)nodeArrayList4.get(0);

        pinstNode1 = new AConditionTantqueInst(ttantqueNode2, pexprNode3, tfaireNode4, pblocinstNode5);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new25() /* reduce AConditionAppelleDeFonctionInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TIdentif tidentifNode2;
        TParenthouvrante tparenthouvranteNode3;
        PListeexpr plisteexprNode4;
        TParenthfermante tparenthfermanteNode5;
        TPtvirgule tptvirguleNode6;
        tidentifNode2 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode3 = (TParenthouvrante)nodeArrayList2.get(0);
        plisteexprNode4 = (PListeexpr)nodeArrayList3.get(0);
        tparenthfermanteNode5 = (TParenthfermante)nodeArrayList4.get(0);
        tptvirguleNode6 = (TPtvirgule)nodeArrayList5.get(0);

        pinstNode1 = new AConditionAppelleDeFonctionInst(tidentifNode2, tparenthouvranteNode3, plisteexprNode4, tparenthfermanteNode5, tptvirguleNode6);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new26() /* reduce AEcrireInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TEcrire tecrireNode2;
        TParenthouvrante tparenthouvranteNode3;
        PExpr pexprNode4;
        TParenthfermante tparenthfermanteNode5;
        TPtvirgule tptvirguleNode6;
        tecrireNode2 = (TEcrire)nodeArrayList1.get(0);
        tparenthouvranteNode3 = (TParenthouvrante)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tparenthfermanteNode5 = (TParenthfermante)nodeArrayList4.get(0);
        tptvirguleNode6 = (TPtvirgule)nodeArrayList5.get(0);

        pinstNode1 = new AEcrireInst(tecrireNode2, tparenthouvranteNode3, pexprNode4, tparenthfermanteNode5, tptvirguleNode6);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new27() /* reduce AConditionReturnInst */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PInst pinstNode1;
        {
            // Block
        TRetour tretourNode2;
        PExpr pexprNode3;
        TPtvirgule tptvirguleNode4;
        tretourNode2 = (TRetour)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tptvirguleNode4 = (TPtvirgule)nodeArrayList3.get(0);

        pinstNode1 = new AConditionReturnInst(tretourNode2, pexprNode3, tptvirguleNode4);
        }
	nodeList.add(pinstNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new28() /* reduce AListeExpressionListeexpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PListeexpr plisteexprNode1;
        {
            // Block
        PExpr pexprNode2;
        PListeexprp plisteexprpNode3;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        plisteexprpNode3 = (PListeexprp)nodeArrayList2.get(0);

        plisteexprNode1 = new AListeExpressionListeexpr(pexprNode2, plisteexprpNode3);
        }
	nodeList.add(plisteexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new29() /* reduce AVideListeexpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        PListeexpr plisteexprNode1;
        {
            // Block

        plisteexprNode1 = new AVideListeexpr();
        }
	nodeList.add(plisteexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new30() /* reduce AListeExpressionPrimeListeexprp */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PListeexprp plisteexprpNode1;
        {
            // Block
        TVirgule tvirguleNode2;
        PExpr pexprNode3;
        PListeexprp plisteexprpNode4;
        tvirguleNode2 = (TVirgule)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        plisteexprpNode4 = (PListeexprp)nodeArrayList3.get(0);

        plisteexprpNode1 = new AListeExpressionPrimeListeexprp(tvirguleNode2, pexprNode3, plisteexprpNode4);
        }
	nodeList.add(plisteexprpNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new31() /* reduce AVideListeexprp */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        PListeexprp plisteexprpNode1;
        {
            // Block

        plisteexprpNode1 = new AVideListeexprp();
        }
	nodeList.add(plisteexprpNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new32() /* reduce AConditionOuExpr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TOu touNode3;
        PExpr1 pexpr1Node4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        touNode3 = (TOu)nodeArrayList2.get(0);
        pexpr1Node4 = (PExpr1)nodeArrayList3.get(0);

        pexprNode1 = new AConditionOuExpr(pexprNode2, touNode3, pexpr1Node4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new33() /* reduce AExpr1Expr */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr1 pexpr1Node2;
        pexpr1Node2 = (PExpr1)nodeArrayList1.get(0);

        pexprNode1 = new AExpr1Expr(pexpr1Node2);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new34() /* reduce AConditionEtExpr1 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr1 pexpr1Node1;
        {
            // Block
        PExpr1 pexpr1Node2;
        TEt tetNode3;
        PExpr2 pexpr2Node4;
        pexpr1Node2 = (PExpr1)nodeArrayList1.get(0);
        tetNode3 = (TEt)nodeArrayList2.get(0);
        pexpr2Node4 = (PExpr2)nodeArrayList3.get(0);

        pexpr1Node1 = new AConditionEtExpr1(pexpr1Node2, tetNode3, pexpr2Node4);
        }
	nodeList.add(pexpr1Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new35() /* reduce AExpr2Expr1 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr1 pexpr1Node1;
        {
            // Block
        PExpr2 pexpr2Node2;
        pexpr2Node2 = (PExpr2)nodeArrayList1.get(0);

        pexpr1Node1 = new AExpr2Expr1(pexpr2Node2);
        }
	nodeList.add(pexpr1Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new36() /* reduce AConditionEgalExpr2 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr2 pexpr2Node1;
        {
            // Block
        PExpr2 pexpr2Node2;
        TEgal tegalNode3;
        PExpr3 pexpr3Node4;
        pexpr2Node2 = (PExpr2)nodeArrayList1.get(0);
        tegalNode3 = (TEgal)nodeArrayList2.get(0);
        pexpr3Node4 = (PExpr3)nodeArrayList3.get(0);

        pexpr2Node1 = new AConditionEgalExpr2(pexpr2Node2, tegalNode3, pexpr3Node4);
        }
	nodeList.add(pexpr2Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new37() /* reduce AConditionInfExpr2 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr2 pexpr2Node1;
        {
            // Block
        PExpr2 pexpr2Node2;
        TInferieur tinferieurNode3;
        PExpr3 pexpr3Node4;
        pexpr2Node2 = (PExpr2)nodeArrayList1.get(0);
        tinferieurNode3 = (TInferieur)nodeArrayList2.get(0);
        pexpr3Node4 = (PExpr3)nodeArrayList3.get(0);

        pexpr2Node1 = new AConditionInfExpr2(pexpr2Node2, tinferieurNode3, pexpr3Node4);
        }
	nodeList.add(pexpr2Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new38() /* reduce AExpr3Expr2 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr2 pexpr2Node1;
        {
            // Block
        PExpr3 pexpr3Node2;
        pexpr3Node2 = (PExpr3)nodeArrayList1.get(0);

        pexpr2Node1 = new AExpr3Expr2(pexpr3Node2);
        }
	nodeList.add(pexpr2Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new39() /* reduce ACondtionPlusExpr3 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr3 pexpr3Node1;
        {
            // Block
        PExpr3 pexpr3Node2;
        TPlus tplusNode3;
        PExpr4 pexpr4Node4;
        pexpr3Node2 = (PExpr3)nodeArrayList1.get(0);
        tplusNode3 = (TPlus)nodeArrayList2.get(0);
        pexpr4Node4 = (PExpr4)nodeArrayList3.get(0);

        pexpr3Node1 = new ACondtionPlusExpr3(pexpr3Node2, tplusNode3, pexpr4Node4);
        }
	nodeList.add(pexpr3Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new40() /* reduce AConditionMoinsExpr3 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr3 pexpr3Node1;
        {
            // Block
        PExpr3 pexpr3Node2;
        TMoins tmoinsNode3;
        PExpr4 pexpr4Node4;
        pexpr3Node2 = (PExpr3)nodeArrayList1.get(0);
        tmoinsNode3 = (TMoins)nodeArrayList2.get(0);
        pexpr4Node4 = (PExpr4)nodeArrayList3.get(0);

        pexpr3Node1 = new AConditionMoinsExpr3(pexpr3Node2, tmoinsNode3, pexpr4Node4);
        }
	nodeList.add(pexpr3Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new41() /* reduce AExpr4Expr3 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr3 pexpr3Node1;
        {
            // Block
        PExpr4 pexpr4Node2;
        pexpr4Node2 = (PExpr4)nodeArrayList1.get(0);

        pexpr3Node1 = new AExpr4Expr3(pexpr4Node2);
        }
	nodeList.add(pexpr3Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new42() /* reduce AConditionMultExpr4 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr4 pexpr4Node1;
        {
            // Block
        PExpr4 pexpr4Node2;
        TMult tmultNode3;
        PExpr5 pexpr5Node4;
        pexpr4Node2 = (PExpr4)nodeArrayList1.get(0);
        tmultNode3 = (TMult)nodeArrayList2.get(0);
        pexpr5Node4 = (PExpr5)nodeArrayList3.get(0);

        pexpr4Node1 = new AConditionMultExpr4(pexpr4Node2, tmultNode3, pexpr5Node4);
        }
	nodeList.add(pexpr4Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new43() /* reduce AConditionDivExpr4 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr4 pexpr4Node1;
        {
            // Block
        PExpr4 pexpr4Node2;
        TDiv tdivNode3;
        PExpr5 pexpr5Node4;
        pexpr4Node2 = (PExpr4)nodeArrayList1.get(0);
        tdivNode3 = (TDiv)nodeArrayList2.get(0);
        pexpr5Node4 = (PExpr5)nodeArrayList3.get(0);

        pexpr4Node1 = new AConditionDivExpr4(pexpr4Node2, tdivNode3, pexpr5Node4);
        }
	nodeList.add(pexpr4Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new44() /* reduce AExpr5Expr4 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr4 pexpr4Node1;
        {
            // Block
        PExpr5 pexpr5Node2;
        pexpr5Node2 = (PExpr5)nodeArrayList1.get(0);

        pexpr4Node1 = new AExpr5Expr4(pexpr5Node2);
        }
	nodeList.add(pexpr4Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new45() /* reduce AConditionNegationExpr5 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr5 pexpr5Node1;
        {
            // Block
        TNegation tnegationNode2;
        PExpr5 pexpr5Node3;
        tnegationNode2 = (TNegation)nodeArrayList1.get(0);
        pexpr5Node3 = (PExpr5)nodeArrayList2.get(0);

        pexpr5Node1 = new AConditionNegationExpr5(tnegationNode2, pexpr5Node3);
        }
	nodeList.add(pexpr5Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new46() /* reduce AExpr6Expr5 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr5 pexpr5Node1;
        {
            // Block
        PExpr6 pexpr6Node2;
        pexpr6Node2 = (PExpr6)nodeArrayList1.get(0);

        pexpr5Node1 = new AExpr6Expr5(pexpr6Node2);
        }
	nodeList.add(pexpr5Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new47() /* reduce AExprExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TParenthouvrante tparenthouvranteNode2;
        PExpr pexprNode3;
        TParenthfermante tparenthfermanteNode4;
        tparenthouvranteNode2 = (TParenthouvrante)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tparenthfermanteNode4 = (TParenthfermante)nodeArrayList3.get(0);

        pexpr6Node1 = new AExprExpr6(tparenthouvranteNode2, pexprNode3, tparenthfermanteNode4);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new48() /* reduce ANombreExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TNombre tnombreNode2;
        tnombreNode2 = (TNombre)nodeArrayList1.get(0);

        pexpr6Node1 = new ANombreExpr6(tnombreNode2);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new49() /* reduce AVraiExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TVrai tvraiNode2;
        tvraiNode2 = (TVrai)nodeArrayList1.get(0);

        pexpr6Node1 = new AVraiExpr6(tvraiNode2);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new50() /* reduce AFauxExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TFaux tfauxNode2;
        tfauxNode2 = (TFaux)nodeArrayList1.get(0);

        pexpr6Node1 = new AFauxExpr6(tfauxNode2);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new51() /* reduce AIdentifiantExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TIdentif tidentifNode2;
        TParenthouvrante tparenthouvranteNode3;
        PListeexpr plisteexprNode4;
        TParenthfermante tparenthfermanteNode5;
        tidentifNode2 = (TIdentif)nodeArrayList1.get(0);
        tparenthouvranteNode3 = (TParenthouvrante)nodeArrayList2.get(0);
        plisteexprNode4 = (PListeexpr)nodeArrayList3.get(0);
        tparenthfermanteNode5 = (TParenthfermante)nodeArrayList4.get(0);

        pexpr6Node1 = new AIdentifiantExpr6(tidentifNode2, tparenthouvranteNode3, plisteexprNode4, tparenthfermanteNode5);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new52() /* reduce ALireExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        TLire tlireNode2;
        TParenthouvrante tparenthouvranteNode3;
        TParenthfermante tparenthfermanteNode4;
        tlireNode2 = (TLire)nodeArrayList1.get(0);
        tparenthouvranteNode3 = (TParenthouvrante)nodeArrayList2.get(0);
        tparenthfermanteNode4 = (TParenthfermante)nodeArrayList3.get(0);

        pexpr6Node1 = new ALireExpr6(tlireNode2, tparenthouvranteNode3, tparenthfermanteNode4);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new53() /* reduce AVariableExpr6 */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PExpr6 pexpr6Node1;
        {
            // Block
        PVar pvarNode2;
        pvarNode2 = (PVar)nodeArrayList1.get(0);

        pexpr6Node1 = new AVariableExpr6(pvarNode2);
        }
	nodeList.add(pexpr6Node1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new54() /* reduce AId1Var */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PVar pvarNode1;
        {
            // Block
        TIdentif tidentifNode2;
        tidentifNode2 = (TIdentif)nodeArrayList1.get(0);

        pvarNode1 = new AId1Var(tidentifNode2);
        }
	nodeList.add(pvarNode1);
        return nodeList;
    }



    @SuppressWarnings({ "unchecked", "rawtypes" })
    ArrayList<Object> new55() /* reduce AId2Var */
    {
        @SuppressWarnings("hiding") ArrayList<Object> nodeList = new ArrayList<Object>();

        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList<Object> nodeArrayList1 = pop();
        PVar pvarNode1;
        {
            // Block
        TIdentif tidentifNode2;
        TCrochetouvrant tcrochetouvrantNode3;
        PExpr pexprNode4;
        TCrochetfermant tcrochetfermantNode5;
        tidentifNode2 = (TIdentif)nodeArrayList1.get(0);
        tcrochetouvrantNode3 = (TCrochetouvrant)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tcrochetfermantNode5 = (TCrochetfermant)nodeArrayList4.get(0);

        pvarNode1 = new AId2Var(tidentifNode2, tcrochetouvrantNode3, pexprNode4, tcrochetfermantNode5);
        }
	nodeList.add(pvarNode1);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 7}, {30, SHIFT, 1}, {31, SHIFT, 2}, {32, SHIFT, 3}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 3}, {5, SHIFT, 9}, },
			{{-1, ERROR, 4}, {33, ACCEPT, -1}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 7}, {30, SHIFT, 1}, {31, SHIFT, 2}, {32, SHIFT, 3}, },
			{{-1, ERROR, 8}, {32, SHIFT, 14}, },
			{{-1, ERROR, 9}, {6, SHIFT, 15}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, ERROR, 10}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, REDUCE, 7}, {30, SHIFT, 1}, {31, SHIFT, 2}, {32, SHIFT, 3}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 13}, {32, SHIFT, 20}, },
			{{-1, REDUCE, 4}, {5, SHIFT, 21}, {7, SHIFT, 22}, },
			{{-1, ERROR, 15}, {9, SHIFT, 23}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, ERROR, 17}, {32, SHIFT, 27}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 0}, },
			{{-1, ERROR, 20}, {5, SHIFT, 21}, },
			{{-1, ERROR, 21}, {6, SHIFT, 29}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, ERROR, 22}, {1, SHIFT, 31}, },
			{{-1, REDUCE, 20}, {2, SHIFT, 32}, {3, SHIFT, 33}, {24, SHIFT, 34}, {27, SHIFT, 35}, {32, SHIFT, 36}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 26}, {6, SHIFT, 41}, },
			{{-1, REDUCE, 4}, {7, SHIFT, 22}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 29}, {9, SHIFT, 23}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, ERROR, 31}, {8, SHIFT, 45}, },
			{{-1, ERROR, 32}, {5, SHIFT, 46}, },
			{{-1, ERROR, 33}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 34}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 35}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 54}, {5, SHIFT, 64}, {7, SHIFT, 65}, },
			{{-1, ERROR, 37}, {10, SHIFT, 66}, },
			{{-1, REDUCE, 20}, {2, SHIFT, 32}, {3, SHIFT, 33}, {24, SHIFT, 34}, {27, SHIFT, 35}, {32, SHIFT, 36}, },
			{{-1, ERROR, 39}, {11, SHIFT, 68}, },
			{{-1, ERROR, 40}, {9, SHIFT, 23}, },
			{{-1, ERROR, 41}, {9, SHIFT, 23}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 44}, {6, SHIFT, 73}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 46}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 48}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 49}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 50}, },
			{{-1, ERROR, 52}, {5, SHIFT, 77}, },
			{{-1, REDUCE, 54}, {5, SHIFT, 78}, {7, SHIFT, 65}, },
			{{-1, ERROR, 54}, {4, SHIFT, 79}, {17, SHIFT, 80}, },
			{{-1, REDUCE, 33}, {18, SHIFT, 81}, },
			{{-1, REDUCE, 35}, {11, SHIFT, 82}, {20, SHIFT, 83}, },
			{{-1, REDUCE, 38}, {12, SHIFT, 84}, {13, SHIFT, 85}, },
			{{-1, REDUCE, 41}, {14, SHIFT, 86}, {15, SHIFT, 87}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 46}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 62}, {17, SHIFT, 80}, {26, SHIFT, 88}, },
			{{-1, ERROR, 63}, {17, SHIFT, 80}, {28, SHIFT, 89}, },
			{{-1, REDUCE, 29}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 65}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 68}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 72}, {9, SHIFT, 23}, },
			{{-1, ERROR, 73}, {9, SHIFT, 23}, {30, SHIFT, 1}, {31, SHIFT, 2}, },
			{{-1, ERROR, 74}, {6, SHIFT, 98}, {17, SHIFT, 80}, },
			{{-1, ERROR, 75}, {6, SHIFT, 99}, {17, SHIFT, 80}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 77}, {6, SHIFT, 100}, },
			{{-1, REDUCE, 29}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 80}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 81}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 82}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 83}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 84}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 85}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 86}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 87}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, ERROR, 88}, {9, SHIFT, 23}, },
			{{-1, ERROR, 89}, {9, SHIFT, 23}, },
			{{-1, ERROR, 90}, {6, SHIFT, 112}, },
			{{-1, REDUCE, 31}, {0, SHIFT, 113}, {17, SHIFT, 80}, },
			{{-1, ERROR, 92}, {8, SHIFT, 115}, {17, SHIFT, 80}, },
			{{-1, ERROR, 93}, {4, SHIFT, 116}, {17, SHIFT, 80}, },
			{{-1, ERROR, 94}, {9, SHIFT, 23}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 3}, {0, SHIFT, 10}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 98}, {4, SHIFT, 119}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 101}, {6, SHIFT, 120}, },
			{{-1, REDUCE, 32}, {18, SHIFT, 81}, },
			{{-1, REDUCE, 34}, {11, SHIFT, 82}, {20, SHIFT, 83}, },
			{{-1, REDUCE, 36}, {12, SHIFT, 84}, {13, SHIFT, 85}, },
			{{-1, REDUCE, 37}, {12, SHIFT, 84}, {13, SHIFT, 85}, },
			{{-1, REDUCE, 39}, {14, SHIFT, 86}, {15, SHIFT, 87}, },
			{{-1, REDUCE, 40}, {14, SHIFT, 86}, {15, SHIFT, 87}, },
			{{-1, REDUCE, 42}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 22}, {25, SHIFT, 121}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 112}, {4, SHIFT, 122}, },
			{{-1, ERROR, 113}, {1, SHIFT, 47}, {5, SHIFT, 48}, {19, SHIFT, 49}, {22, SHIFT, 50}, {23, SHIFT, 51}, {29, SHIFT, 52}, {32, SHIFT, 53}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 118}, {9, SHIFT, 23}, },
			{{-1, REDUCE, 26}, },
			{{-1, REDUCE, 51}, },
			{{-1, ERROR, 121}, {9, SHIFT, 23}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 31}, {0, SHIFT, 113}, {17, SHIFT, 80}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 30}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 4}, },
			{{-1, 11}, {16, 26}, {18, 28}, {24, 40}, {30, 44}, {42, 72}, {70, 94}, {96, 118}, },
			{{-1, 5}, {9, 16}, {10, 18}, {15, 24}, {21, 30}, {29, 42}, {41, 70}, {73, 96}, },
			{{-1, 6}, {7, 12}, {11, 19}, },
			{{-1, 7}, },
			{{-1, 17}, {0, 8}, {7, 13}, {11, 13}, },
			{{-1, 25}, {29, 43}, {40, 69}, {41, 71}, {72, 95}, {73, 97}, {88, 110}, {89, 111}, {94, 117}, {118, 124}, {121, 125}, },
			{{-1, 37}, {38, 67}, },
			{{-1, 38}, },
			{{-1, 90}, {78, 101}, },
			{{-1, 114}, {123, 126}, },
			{{-1, 91}, {33, 54}, {34, 62}, {35, 63}, {46, 74}, {48, 75}, {65, 92}, {68, 93}, {113, 123}, },
			{{-1, 55}, {80, 102}, },
			{{-1, 56}, {81, 103}, },
			{{-1, 57}, {82, 104}, {83, 105}, },
			{{-1, 58}, {84, 106}, {85, 107}, },
			{{-1, 59}, {49, 76}, {86, 108}, {87, 109}, },
			{{-1, 60}, },
			{{-1, 61}, {23, 39}, {38, 39}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'entier', 'bool', identif, EOF",
			"expecting: identif",
			"expecting: '('",
			"expecting: EOF",
			"expecting: ',', 'entier', 'bool', identif, EOF",
			"expecting: ')', 'entier', 'bool'",
			"expecting: 'entier', 'bool'",
			"expecting: ',', '(', '[', 'entier', 'bool', identif, EOF",
			"expecting: '{', 'entier', 'bool'",
			"expecting: ',', ')'",
			"expecting: ',', ')', '{', 'entier', 'bool', identif, EOF",
			"expecting: nombre",
			"expecting: 'ecrire', 'retour', '}', 'si', 'tantque', identif",
			"expecting: ',', '{'",
			"expecting: ')'",
			"expecting: ',', ')', '[', '{', 'entier', 'bool', identif, EOF",
			"expecting: ')', '{', 'entier', 'bool', identif, EOF",
			"expecting: ']'",
			"expecting: nombre, '(', '!', 'vrai', 'faux', 'lire', identif",
			"expecting: '(', '[', '='",
			"expecting: '}'",
			"expecting: '='",
			"expecting: '{'",
			"expecting: ',', ';', ')', ']', '=', '+', '-', '*', '/', '|', '&', '<', 'alors', 'faire'",
			"expecting: ',', ';', '(', ')', '[', ']', '=', '+', '-', '*', '/', '|', '&', '<', 'alors', 'faire'",
			"expecting: ';', '|'",
			"expecting: ',', ';', ')', ']', '|', '&', 'alors', 'faire'",
			"expecting: ',', ';', ')', ']', '=', '|', '&', '<', 'alors', 'faire'",
			"expecting: ',', ';', ')', ']', '=', '+', '-', '|', '&', '<', 'alors', 'faire'",
			"expecting: '|', 'alors'",
			"expecting: '|', 'faire'",
			"expecting: nombre, '(', ')', '!', 'vrai', 'faux', 'lire', identif",
			"expecting: 'ecrire', 'retour', '}', 'si', 'sinon', 'tantque', 'entier', 'bool', identif, EOF",
			"expecting: ')', '|'",
			"expecting: ',', ')', '|'",
			"expecting: ']', '|'",
			"expecting: ';'",
			"expecting: 'ecrire', 'retour', '}', 'si', 'sinon', 'tantque', identif",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 2, 3, 4, 3, 0, 1, 5, 6, 0, 3, 1, 7, 8, 9, 1, 10, 3, 2, 5, 11, 12, 13, 0, 14, 15, 16, 8, 9, 17, 2, 18, 18, 18, 19, 20, 12, 21, 22, 8, 13, 0, 14, 10, 18, 23, 18, 18, 23, 23, 2, 24, 25, 26, 27, 28, 23, 23, 23, 23, 29, 30, 31, 18, 32, 20, 18, 0, 13, 0, 22, 8, 33, 33, 23, 14, 31, 12, 18, 18, 18, 18, 18, 18, 18, 18, 22, 22, 14, 34, 35, 25, 22, 0, 13, 0, 36, 23, 23, 14, 26, 27, 28, 28, 23, 23, 23, 23, 37, 12, 36, 18, 14, 23, 12, 0, 22, 12, 23, 22, 12, 34, 0, 12, 14, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
